################################################
#            zABBER Procedure File             #
################################################
#                                              #
#   This file has nearly all the procs zABBER  #
#   uses.                                      #
#                                              #
################################################

proc client:jabber:server {protocol version} {}

proc zabber:connect {} {
global jabber

  if {$jabber(misc,showpasswin)} {
	if {[passwin]=="-1"} {set jabber(status) "offline"; return}
  }

  .win.f0.men25 configure -text "Connecting..."
  update idletasks
  if {[JabberLib:jabber:connect $jabber(server) "zABBER test version 1.1" \
		$jabber(username) $jabber(nick) $jabber(pass)]==-1} {

	set jabber(status) "offline"
	.win.f0.men25 configure -text Offline
	tk_messageBox -message "An error occured while trying to connect $jabber(server)\nPlease check your connection" -parent .win
	return
  }

  .win.m.roster entryconfigure 0 -state normal
  .win.m.roster entryconfigure 5 -state normal

  JabberLib:roster:reget

# We souldn't send our status when we connect...
# JabberLib:change:status $jabber(status) "This is my status" $jabber(priority) $jabber(condition)

  switch -- $jabber(status) {
	online  {.win.f0.men25 configure -text Online}
	OFFLINE {.win.f0.men25 configure -text Privacy}
	offline {.win.f0.men25 configure -text Offline}
  }

}

proc zabber:disconnect {} {
global jabber JabberLib

  #We first delete everything in our widget
  foreach group $JabberLib(roster,groups) {Tree:delitem .win.f.tree "/$group"}

  JabberLib:jabber:disconnect

  .win.m.roster entryconfigure 0 -state disabled
  .win.m.roster entryconfigure 2 -state disabled
  .win.m.roster entryconfigure 3 -state disabled
  .win.m.roster entryconfigure 5 -state disabled

  set jabber(status) "offline"
  .win.f0.men25 configure -text "Offline"
}

proc client:jabber:offline {} {
global jabber

tk_messageBox -message "Server $jabber(server) closed connection."

set jabber(status) "offline"
.win.f0.men25 configure -text Offline
}

proc zabber:deluser {user group} {
  if {[tk_messageBox -icon question -parent .win -type yesno -title "Delete User" \
       -message "Are you sure you want to delete this user?"]=="no"} {return}

  JabberLib:roster:deluser $group $user
  Tree:delitem .win.f.tree "/$group/$user"
}

proc zabber:delgroup {group} {
  if {[tk_messageBox -icon question -parent .win -type yesno -title "Delete Group" \
       -message "Are you sure you want to delete this group?"]=="no"} {return}

  JabberLib:roster:delgroup $group
  Tree:delitem .win.f.tree "/$group"
}

proc client:roster:group {group} {
global JabberLib
	catch {Tree:newitem .win.f.tree "/$group"}
#
# Move tree 1 units down, to avoid space above text
#
	if {[llength $JabberLib(roster,groups)]==1} {.win.f.tree yview scroll 1 units}
}

proc client:roster:user {group user} {
global JabberLib

	catch {Tree:newitem .win.f.tree "/$group/$user"}

	foreach nick $JabberLib(roster,users,$user) {
		#   Here we send a "nick" command so the nicks under
		# user (if the user already in another group) are updated

		client:roster:nick $user $nick [JabberLib:roster:getinfo $user $nick]
	}
	zabber:setusericon $user
	blink:user $user
}

proc client:roster:nick {user nick prop} {
global JabberLib

set type [lindex $prop 0]
set msg  [lindex $prop 1]
set pri  [lindex $prop 2]
set icon [lindex $prop 3]


	foreach a $JabberLib(roster,groups) {
		if {[lsearch $JabberLib(roster,groups,$a) $user]!=-1} {
			if {$type=="offline"} {
					catch {Tree:newitem .win.f.tree /$a/$user/$nick -image idisconnect} ;#We try to create a new nick under Tree Widget in case there isn't
					Tree:cfgitem .win.f.tree /$a/$user/$nick -image idisconnect
					return} \
				elseif {$type=="online"} {catch {Tree:newitem .win.f.tree /$a/$user/$nick -image iconnect}}
		}
	}

	foreach a $JabberLib(roster,groups) {
		if {[lsearch $JabberLib(roster,groups,$a) $user]!=-1} {
			switch -- $icon {
				"happy"       {Tree:cfgitem .win.f.tree /$a/$user/$nick -image ihappy}
				"programming" {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iprogramming}
				"playing"     {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iplaying}
				"eating"      {Tree:cfgitem .win.f.tree /$a/$user/$nick -image ieating}
				"normal"      {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iconnect}
				"away"        {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iaway}
				"sad"         {Tree:cfgitem .win.f.tree /$a/$user/$nick -image isad}
				"angry"       {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iangry}
				default       {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iconnect}
			}
		}
	}
#
# Here we call the blink:nick proc, just to control if the nick needs to be blinked...
#
	zabber:setusericon $user
	blink:nick $user $nick
}

proc client:msg:error {from subject msg ext} {
global jabber
errorwin .mes$jabber(mesnum) $subject $msg
incr jabber(mesnum)
if {$jabber(misc,beeponerr)==1} {bell}
}

proc client:msg:normal {from nick subject thread pri msg exttags extvals exttxts} {
global jabber JabberLib script

script:refresh

set found "0"
lappend exttags ""
lappend extvals ""
lappend exttxts ""

  foreach exttag $exttags extval $extvals exttxt $exttxts {
    foreach file $script(files) {
      set a [lindex $script(files,$file) 5]
#
# New interp
#
      foreach b $a {
        if {[string match [lindex $b 0] $subject] && \
	    [string match [lindex $b 1] $msg] && \
	    [string match [lindex $b 2] $pri] && \
	    [string match [lindex $b 3] $thread] && \
	    [string match [lindex $b 4] $from] && \
	    [string match [lindex $b 5] $nick] && \
	    [string match [lindex $b 6] $exttag] && \
	    [string match [lindex $b 8] $exttxt]} {if {[script:match:value $extval "[lindex $b 7]"]==1} {set found 1
													 set temp [script:decrypt:Message "[lindex $b 9]" "$subject" "$msg" "$pri" "$thread" "$from" "$nick" "$exttag" "$extval" "$exttxt"]
													 script:start $file $temp
													 break}}
      }
      script:refresh
#
# Existing interp
#
      foreach interp $script(interp,$file) {
	foreach x $script(interp,$file:$interp) {
	  if {[string match [lindex $x 0] $subject] && \
	    [string match [lindex $x 1] $msg] && \
	    [string match [lindex $x 2] $pri] && \
	    [string match [lindex $x 3] $thread] && \
	    [string match [lindex $x 4] $from] && \
	    [string match [lindex $x 5] $nick] && \
	    [string match [lindex $x 6] $exttag] && \
	    [string match [lindex $x 8] $exttxt]} {if {[script:match:value $extval "[lindex $x 7]"]!=0} {set found 1
										   			 set temp [script:decrypt:Message "[lindex $x 9]" "$subject" "$msg" "$pri" "$thread" "$from" "$nick" "$exttag" "$extval" "$exttxt"]
													 $interp eval $temp
													 break}}
	}
      }
    }
  }

#
# We don't show the message if it's for a script.
#
  if {$found} {return}

if {[string match "URL: *" $subject]} {set type "URL"; set subject [string range $subject 5 end]} else {set type "MESSAGE"}

if {[lsearch $jabber(messages) $from]==-1} {lappend jabber(messages) $from}

lappend abc $nick $subject $thread $pri $msg $type "0"
lappend jabber(messages,$from) $abc

set a "meswin_$from"
set b "_"
set base ""
for {set i 0} {$i<[string length $a]} {incr i} {
  set ch [string index $a $i]
  if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}}
set base ".$base"

if {$pri>=1000} {blink:secretf}
if {$jabber(misc,beeponmsg)==1} {bell}
if {[lsearch $JabberLib(roster,users) $from]==-1} {blink:secretf; return}
if {[winfo exists $base]} {receivewin $from "new"}
blink:user $from
if {[lsearch $JabberLib(roster,users,$from) $nick]==-1} {return}

set a "nickmeswin_$from.$nick"
set b "_"
set base ""
for {set i 0} {$i<[string length $a]} {incr i} {
  set ch [string index $a $i]
  if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}}
set base ".$base"

if {[winfo exists $base]} {nickreceivewin $from $nick "new"}
blink:nick $from $nick
}

proc rtrimleft {bigstr srcstr} {
set istring1 [string length $srcstr]
if {$srcstr == [string range $bigstr 0 [expr $istring1-1]]} {
  return [string range $bigstr $istring1 end] }
}
proc findfirst {srcstr bigstr start} {
set text [string range $bigstr $start end]
if {[set index [string first $srcstr $text]]!=-1} \
  {return [expr $start+$index]} else {return -1}
}

proc findlast {srcstr bigstr end} {
set text [string range $bigstr 0 $end]
if {[set index [string last $srcstr $text]]!=-1} \
  {return $index} else {return -1}
}

proc zabber:sendmsg {base} {
  set to [split [$base.f0.f0.to get] ","] ;#Here we accept multiple "to"s separated with commas
  set nick [$base.f0.f0.nick get]
  set thread [$base.f0.f0.thread get]
  set priority [$base.f0.f0.pri get]
  set subject [$base.f0.f1.subject get]
  set message [$base.f1.text get 1.0 end]

  JabberLib:send:message $to $nick $subject $thread $priority $message ""
}

proc zabber:sendurl {base} {
  set to [split [$base.f0.f0.to get] ","] ;#Here we accept multiple "to"s separated with commas
  set nick [$base.f0.f0.nick get]
  set thread [$base.f0.f0.thread get]
  set priority [$base.f0.f0.pri get]
  set subject "URL: [$base.f0.f1.subject get]"
  set message [$base.f1.text get 1.0 end]

  JabberLib:send:message $to $nick $subject $thread $priority $message ""
}

#
# Priority sort for tree widget
# Returns -1, 0, or 1 depending on the values
#
proc zabber:prisort {user nick1 nick2} {
global JabberLib

  set pri1 [lindex $JabberLib(roster,users,$user,$nick1) 2]
  set pri2 [lindex $JabberLib(roster,users,$user,$nick2) 2]

  if {$pri1<$pri2 && $pri1>-1} {return -1} \
    elseif {$pri1<$pri2 && $pri1<0} {return 1} \
    elseif {$pri1>$pri2 && $pri2>-1} {return 1} \
    elseif {$pri1>$pri2 && $pri2<0} {return -1} \
    elseif {$pri1==$pri2} {return 0}
}

#
# Changes the given message to replied form (each line starting with "> ")
#
proc zabber:replymsg {mes from} {
set startchar "> "
set endchar "\n"
set newmes "\n     $from wrote:\n"

  foreach a [split $mes \{"\n"\}] {set newmes $newmes$startchar$a$endchar}
  return $newmes
}

#
# Runs browser to visit link (if defined), if not defined asks etc..
#
proc linkvisit {link} {
global jabber tcl_platform cfile

  set types {{{All Files} {*}}}

  if {$tcl_platform(platform)=="windows"} {
	exec start $link &
  } else {
	if {$jabber(misc,browser)=="" || [file exists $jabber(misc,browser)]==0} {
		if {[tk_messageBox -type yesno -title Question? -icon question -message {A browser isn't selected or it doesn't exist anymore. Do you want to select a browser for links?}]=="no"} {return}
	        set a [tk_getOpenFile -filetypes $types -initialdir / -title "Select Browser"]
		if {$a==""} {return} else {set jabber(misc,browser) $a; writeini $cfile browser $a}
	}
	exec $jabber(misc,browser) $link &
  }
}

#
# Blinks a user's icon, stops if cannot find more messages.
#
proc blink:user {user} {
global JabberLib jabber

  if {![info exists jabber(messages,$user)]} {return}
  if {$jabber(messages,$user)==""} {return}

  set groups ""
# First, we find the groups the user is in.
  foreach grp $JabberLib(roster,groups) {if {[lsearch $JabberLib(roster,groups,$grp) $user]!=-1} {lappend groups $grp}}

  set type [lindex [lindex $jabber(messages,$user) 0] 5]
  if {$type=="URL"} {foreach grp $groups {Tree:cfgitem .win.f.tree "/$grp/$user" -image "iurl"}} \
    else {foreach grp $groups {Tree:cfgitem .win.f.tree "/$grp/$user" -image "imessage"}}

  set first "set user \{$user\};"
  set last {set groups ""
	    foreach grp $JabberLib(roster,groups) {if {[lsearch $JabberLib(roster,groups,$grp) $user]!=-1} {lappend groups $grp}}
	    zabber:setusericon $user
	    after 500 "blink:user \{$user\}"
	    unset user groups grp}
  after 500 "$first$last"
}

#
# Blinks a nick's icon, stops if cannot find more messages.
#
proc blink:nick {user nick} {
global JabberLib jabber

  if {![info exists jabber(messages,$user)]} {return}

  set found 0
  foreach abc $jabber(messages,$user) {if {[lindex $abc 0]==$nick} {set found 1; set type [lindex $abc 5]; break}}
  if {!$found} {return}

  set groups ""
# First, we find the groups the user is in.
  foreach grp $JabberLib(roster,groups) {if {[lsearch $JabberLib(roster,groups,$grp) $user]!=-1} {lappend groups $grp}}

  if {$type=="URL"} {foreach grp $groups {Tree:cfgitem .win.f.tree "/$grp/$user/$nick" -image "iurl"}} \
    else {foreach grp $groups {Tree:cfgitem .win.f.tree "/$grp/$user/$nick" -image "imessage"}}

  set first "set user \{$user\};set nick \{$nick\};"
  set last {set groups ""
	    foreach grp $JabberLib(roster,groups) {if {[lsearch $JabberLib(roster,groups,$grp) $user]!=-1} {lappend groups $grp}}
	    foreach grp $groups {switch -- $JabberLib(roster,users,$user,$nick) {
					"happy"       {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image ihappy}
					"programming" {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image iprogramming}
					"playing"     {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image iplaying}
					"eating"      {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image ieating}
					"normal"      {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image iconnect}
					"away"        {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image iaway}
					"sad"         {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image isad}
					"angry"       {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image iangry}
					default       {Tree:cfgitem .win.f.tree /$grp/$user/$nick -image iconnect}
				 }}
	    after 500 "blink:nick \{$user\} \{$nick\}"
	    unset user nick groups grp}
  after 500 "$first$last"
}

proc blink:secretf {} {
global jabber JabberLib

  set jabber(blinker,toppri)      ""
  set jabber(blinker,notinroster) ""

  foreach user $jabber(messages) {
	set num 0
	foreach msg $jabber(messages,$user) {
		if {[lindex $msg 3]>=1000 && [lindex $msg 6]==0} {set msg [linsert $msg 0 $user]
								  lappend msg $num
								  lappend jabber(blinker,toppri) $msg}
		incr num
	}

	if {[lsearch $JabberLib(roster,users) $user]==-1} {lappend jabber(blinker,notinroster) $user}
  }
  set jabber(blinker,toppri) [lsort -integer -decreasing -index 4 $jabber(blinker,toppri)]

  if {$jabber(blinker,toppri)!=""} {
	.win.secretf configure -background #FF0000
	.win.secretf.l0 configure -background #FF0000
	.win.secretf.l1 configure -background #FF0000 -image icaution_
	.win.secretf.l2 configure -background #FF0000 -text "Top Priority"
	.win.secretf.l3 configure -background #FF0000

	pack forget .win.f0
	pack .win.secretf -anchor center -expand 0 -fill x -side top
	pack .win.f0 -anchor center -expand 0 -fill x -side top 
	bell

	set cmd {secretreceivewin
		 bind .win.secretf <Double-1> {}
		 bind .win.secretf.l0 <Double-1> {}
		 bind .win.secretf.l1 <Double-1> {}
		 bind .win.secretf.l2 <Double-1> {}
		 bind .win.secretf.l3 <Double-1> {}
		}
	bind .win.secretf    <Double-1> $cmd
	bind .win.secretf.l0 <Double-1> $cmd
	bind .win.secretf.l1 <Double-1> $cmd
	bind .win.secretf.l2 <Double-1> $cmd
	bind .win.secretf.l3 <Double-1> $cmd

	after 500 {.win.secretf configure -background #BCBCBC
		   .win.secretf.l0 configure -background #BCBCBC
		   .win.secretf.l1 configure -background #BCBCBC -image icaution
		   .win.secretf.l2 configure -background #BCBCBC -text "Top Priority"
		   .win.secretf.l3 configure -background #BCBCBC
		   after 500 blink:secretf}
    } elseif {$jabber(blinker,notinroster)!=""} {
	.win.secretf configure -background #00FF00
	.win.secretf.l0 configure -background #00FF00
	.win.secretf.l1 configure -background #00FF00 -image iquestion_
	.win.secretf.l2 configure -background #00FF00 -text "From: [lindex $jabber(blinker,notinroster) 0]"
	.win.secretf.l3 configure -background #00FF00

	pack forget .win.f0
	pack .win.secretf -anchor center -expand 0 -fill x -side top
	pack .win.f0 -anchor center -expand 0 -fill x -side top 

	set cmd {receivewin "[lindex $jabber(blinker,notinroster) 0]" "new"
		 bind .win.secretf <Double-1> {}
		 bind .win.secretf.l0 <Double-1> {}
		 bind .win.secretf.l1 <Double-1> {}
		 bind .win.secretf.l2 <Double-1> {}
		 bind .win.secretf.l3 <Double-1> {}
		}
	bind .win.secretf    <Double-1> $cmd
	bind .win.secretf.l0 <Double-1> $cmd
	bind .win.secretf.l1 <Double-1> $cmd
	bind .win.secretf.l2 <Double-1> $cmd
	bind .win.secretf.l3 <Double-1> $cmd

	after 500 {.win.secretf configure -background #BCBCBC
		   .win.secretf.l0 configure -background #BCBCBC
		   .win.secretf.l1 configure -background #BCBCBC -image iquestion
		   .win.secretf.l2 configure -background #BCBCBC -text "From: [lindex $jabber(blinker,notinroster) 0]"
		   .win.secretf.l3 configure -background #BCBCBC
		   after 500 blink:secretf}
    } else {pack forget .win.secretf; return}
}

#
# This proc simply updates a user's (username's) icons, according to the first nick in priority-sort.
#
proc zabber:setusericon {user} {
global jabber JabberLib

  set status ""

  set list $JabberLib(roster,users,$user)

  set nname [lindex [lsort -command "zabber:prisort $user" $list] 0]
  catch {set status [lindex $JabberLib(roster,users,$user,$nname) 0]}

  if {$status=="online"} {
	set icon [lindex $JabberLib(roster,users,$user,$nname) 3]
	foreach a $JabberLib(roster,groups) {
		if {[lsearch $JabberLib(roster,groups,$a) $user]!=-1} {
			switch -- $icon {
				"happy"       {Tree:cfgitem .win.f.tree /$a/$user -image ihappy}
				"programming" {Tree:cfgitem .win.f.tree /$a/$user -image iprogramming}
				"playing"     {Tree:cfgitem .win.f.tree /$a/$user -image iplaying}
				"eating"      {Tree:cfgitem .win.f.tree /$a/$user -image ieating}
				"normal"      {Tree:cfgitem .win.f.tree /$a/$user -image iconnect}
				"away"        {Tree:cfgitem .win.f.tree /$a/$user -image iaway}
				"sad"         {Tree:cfgitem .win.f.tree /$a/$user -image isad}
				"angry"       {Tree:cfgitem .win.f.tree /$a/$user -image iangry}
				default       {Tree:cfgitem .win.f.tree /$a/$user -image iconnect}
			}
		}
	}
  } else {
	foreach a $JabberLib(roster,groups) {
		if {[lsearch $JabberLib(roster,groups,$a) $user]!=-1} {
			Tree:cfgitem .win.f.tree /$a/$user -image idisconnect
		}
	}
  }
}
