#! /usr/bin/wish
################################################
#               zABBER Main File               #
################################################
#                                              #
#   This is the main file of zABBER. If you    #
#   do not know how to run this code, read     #
#   the README file.                           #
#                                              #
################################################

wm withdraw .
proc splash {} {
    toplevel .x -bd 0
    wm withdraw .x
    set sw [winfo screenwidth .]
    set sh [winfo screenheight .]
    image create photo "logo" -file "Pix/logo.gif"
    wm overrideredirect .x 1
    label .x.l -image logo -bd 0 -relief flat
    pack .x.l -side top -expand 1 -fill both
    set x [expr ($sw - 200)/2]
    set y [expr ($sh - 250)/2]
    wm geometry .x +$x+$y
    wm deiconify .x
    update
}

splash

set jabber(username) "username"
set jabber(pass) "pass"
set jabber(nick) "nick"
set jabber(server) "127.0.0.1"

set jabber(condition) "normal"
set jabber(status) "offline"
set jabber(priority) "0"

set jabber(mesnum) "0"
set jabber(messages)            ""  ;# Names of persons currently sent msgs.
set jabber(blinker,toppri)      ""  ;# A list containing sublists: {user nick sub thr pri say type}. The list is regenerated each time blink:secretf is called.
set jabber(blinker,notinroster) ""  ;# A list containing usernames that are notin roster, but have messages received. The list is regenerated each time blink:secretf is called.

source ./JabberLib/jabberlib.tcl

source ./Widget/tree.tcl
source ./Widget/spinbutton.tcl
source ./Widget/combobox.tcl
source ./Widget/notebook.tcl
source other.tcl
source menus.tcl
source procs.tcl
source windows.tcl
source configure.tcl

package require combobox 1.06
catch {namespace import combobox::*}


#################
# 
# zABBER code starts here...
# 

image create photo icaution  -file "./Pix/caution.ppm"
image create photo icaution_ -file "./Pix/caution_.ppm"
image create photo iquestion  -file "./Pix/question.ppm"
image create photo iquestion_ -file "./Pix/question_.ppm"

image create photo imessage -file "./Pix/message.ppm"
image create photo iurl -file "./Pix/url.ppm"
#image create photo ifile -file "./Pix/file.ppm" ;#Not used....

image create photo idisconnect -file "./Pix/offline.ppm"
image create photo ihappy -file "./Pix/happy.ppm"
image create photo iprogramming -file "./Pix/program.ppm"
image create photo iplaying -file "./Pix/playing.ppm"
image create photo ieating -file "./Pix/eating.ppm"
image create photo iconnect -file "./Pix/online.ppm"
image create photo iaway -file "./Pix/away.ppm"
image create photo isad -file "./Pix/sad.ppm"
image create photo iangry -file "./Pix/angry.ppm"

loadconfig
drawwindow
debugwin

.win.f.tree bind x <1> {
  set lbl [Tree:labelat %W %x %y]
  Tree:setselection %W $lbl

  set a [llength [file split $lbl]]
    if {$a==3} {
	.win.m.roster entryconfigure 2 -state disabled
	.win.m.roster entryconfigure 3 -state normal} \
    elseif {$a==2} {
	.win.m.roster entryconfigure 2 -state normal
	.win.m.roster entryconfigure 3 -state disabled} \
    else {
	.win.m.roster entryconfigure 2 -state disabled
	.win.m.roster entryconfigure 3 -state disabled}
  unset a
}

.win.f.tree bind x <3> {
  set lbl [Tree:labelat %W %x %y]
  Tree:setselection %W $lbl
  set x [expr [winfo x .win.f.tree]+%X]     ;#We get x coordinate on the screen
  set y [expr [winfo y .win.f.tree]+%Y]     ;#We get y coordinate on the screen
  set a [llength [file split $lbl]]

  if {$a==2} {tk_popup .popup_group $x $y} \
    elseif {$a==3} {tk_popup .popup_user $x $y} \
    elseif {$a==4} {tk_popup .popup_nick $x $y}

  if {$a==3} {
    .win.m.roster entryconfigure 2 -state disabled
    .win.m.roster entryconfigure 3 -state normal} \
  elseif {$a==2} {
    .win.m.roster entryconfigure 2 -state normal
    .win.m.roster entryconfigure 3 -state disabled} \
  else {
    .win.m.roster entryconfigure 2 -state disabled
    .win.m.roster entryconfigure 3 -state disabled}

  unset x y a
}

.win.f.tree bind x <Double-1> {
if {[llength [file split [Tree:getselection .win.f.tree]]]==4} {
	    set uname [lindex [file split [Tree:getselection .win.f.tree]] 2]
	    set nname [file tail [Tree:getselection .win.f.tree]]
	    set found 0
	    if {[info exists jabber(messages,$uname)]} {foreach abc $jabber(messages,$uname) {if {[lindex $abc 0]==$nname} {set found 1; break}}}
	    if {!$found} {set wname "_$nname"
			  set wname "$uname$wname"
			  sendwin .mes_$wname $uname $nname "" "" "" "MESSAGE"
			  unset uname nname wname} \
	    else {set a "nickmeswin_$uname.$nname"
		  set b "_"
		  set base ""
		  for {set i 0} {$i<[string length $a]} {incr i} {
		    set ch [string index $a $i]
		    if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}}
		  set base ".$base"

		  if {[winfo exists $base]} {nickreceivewin $uname $nname next} else {nickreceivewin $uname $nname new}
	    }
	} \
  elseif {[llength [file split [Tree:getselection .win.f.tree]]]==3} {
	set uname [file tail [Tree:getselection .win.f.tree]]
	set found 0
	if {[info exists jabber(messages,$uname)]} {if {$jabber(messages,$uname)!=""} {set found 1}}
	if {!$found} {sendwin .mes_$uname $uname "" "" "" "" "MESSAGE"; unset uname} \
	  else {set a "meswin_$uname"
		set b "_"
		set base ""
		for {set i 0} {$i<[string length $a]} {incr i} {
		  set ch [string index $a $i]
		  if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}}
		set base ".$base"

		if {[winfo exists $base]} {receivewin $uname next} else {receivewin $uname new}}} \
  else {Tree:open %W  [Tree:labelat %W %x %y]}
}

after 3000 {catch {destroy .x}}
update

wm withdraw .x
wm deiconify .x
update
